#include <stdio.h>
#include <stdlib.h>

/// suma cifara broja rekurzivno
int suma_cifara(int n) {
    if (n < 10)
        return n;
    else
        return n%10 + suma_cifara(n/10);
}

/**
Napisati rekurzivnu funkciju int evenDigits(int n) koja izbacuje sve parne cifre
datog prirodnog broja n. Ukoliko se n sastoji samo od parnih cifara, vratiti 0.
*/
int evenDigits(int n) {
    if (n < 10) {
        if (n % 2 == 0)
            return 0;
        else
            return n;
    }
    int c = n%10;
    if (c % 2 == 0)
        return evenDigits(n / 10);
    else
        return 10 * evenDigits(n / 10) + c;
}

/**
za vjezbu:
Napisati rekurzivnu funkciju int oddDigits(int n), koja vraća broj
koji se dobije tako što se iza svake neparne cifre broja n doda 0.
*/

/**
za vjezbu:
Napisati rekurzivnu funkciju int digitalRoot(int n) koja izračunava
digitalni korijen prirodnog broja n. Ako je suma cifara s(n) broja n
jednocifren broj, tada je s(n) digitalni korijen. Ako s(n) nije jednocifren,
tada se postupak ponavlja sa s(n) sve dok se ne dobije jednocifren broj.
*/

///pretvaranje broja iz dekadnog u binarni zapis
int dec2bin(int n) {
    if (n <= 1)
        return n;
    else
        return 10 * dec2bin(n / 2) + n % 2;
}

/// permutacije
void permutacije(int n, int k, int p[]) {
    if (k == n) {
        int i;
        for (i = 0; i < n; i++) {
            printf("%d ", p[i]);
        }
        printf("\n");
        return;
    }
    int i;
    for (i = 1; i <= n; i++) {
        int j;
        int ind = 0;
        for (j = 0; j < k; j++) {
            if (i == p[j]) {
                ind = 1;
                break;
            }
        }
        if (ind == 0) {
            p[k] = i;
            permutacije(n, k+1, p);
        }
    }
}

void permutacije_sa_ponavljanjem(int n, int k, int p[]) {
    if (k == n) {
        int i;
        for (i = 0; i < n; i++) {
            printf("%d ", p[i]);
        }
        printf("\n");
        return;
    }
    int i;
    for (i = 1; i <= n; i++) {
        p[k] = i;
        permutacije_sa_ponavljanjem(n, k+1, p);
    }
}

int pop[100];

void print_pop(int k) {
    int i;
    printf("|");
    for (i = 0; i < k; i++) {
        if (pop[i] == 1) {
            printf("*|");
        }
        else {
            printf("* *|");
        }
    }
    printf("\n");
}

void poplocavanje(int n, int k) {
    if (n == 1) {
        pop[k] = 1;
        print_pop(k + 1);
        return;
    }
    else if (n == 2) {
        pop[k] = 1;
        pop[k+1] = 1;
        k += 2;
        print_pop(k);
        k -= 2;
        pop[k] = 2;
        k += 1;
        print_pop(k);
        return;
    }
    pop[k] = 1;
    poplocavanje(n-1, k+1);
    pop[k] = 2;
    poplocavanje(n-2, k+1);
}

int main()
{
    printf("%d\n", suma_cifara(2023));

    printf("%d\n", evenDigits(2023));
    printf("%d\n", evenDigits(1258));
    printf("%d\n", evenDigits(26));
    printf("%d\n", evenDigits(357));

    printf("%d\n", dec2bin(25));
    printf("%d\n", dec2bin(32));
    printf("%d\n", dec2bin(7));

    int n = 4;
    int p[n];
    permutacije(n, 0, p);
    //permutacije_sa_ponavljanjem(n, 0, p);

    //poplocavanje(5, 0);

    return 0;
}
